<?php

date_default_timezone_set("Portugal");
session_start();
$per = explode(",", $_SESSION['password']);
$idUser = $per[0];
$nameUser = $per[1];
$nivelUser = $per[3];

$op=$_POST['op'];
$infoAdicional=$_POST['infoAdicional'];

include('../bdcon.php');


function calculaRMesDia($valor)
{
     //$con = mysqli_connect("localhost", "bluemark_OMHwp", "dtZtX8e9Xd1X", "bluemark_OMHwp")or die(json_encode("unconnected"));

     //coverte dados da tabela para utf8 devido aos acentos nos textos da tabela
     if (!mysqli_set_charset($con, "utf8")) 
     {
           json_encode("erro de caracter");
     } 

     $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History GROUP BY Lead ORDER BY DataHoraRegisto desc");

     while ($row = mysqli_fetch_assoc($result))// mysqli_fetch_array($result, MYSQL_ASSOC)) 
     {
         $leads[]=$row;
     }


     for($i=0;$i<sizeof($leads);$i++)
     {
          $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History where Lead='".$leads[$i]['Lead']."' order by DataHoraRegisto desc");

          $valorV=0;
          $fal=0;

          while ($row = mysqli_fetch_assoc($result))// mysqli_fetch_array($result, MYSQL_ASSOC))  
          {
              if($fal==0)
              {
                  $est=$row['Estado'];
              }

              $valorV += $row['ValorVenda'];
              $fal++;
          }

          $row = mysqli_fetch_assoc($result);// mysqli_fetch_array($result, MYSQL_ASSOC);

          $leads[$i]['Estado']=$est;
          $leads[$i]['ValorVenda']=$valorV;
          $leads[$i]['DataHoraRegisto']=substr($leads[$i]['DataHoraRegisto'], 0, $valor);
     }

     $data="";

     for($i=0;$i<sizeof($leads);$i++)
     {
          $data=$leads[$i]['DataHoraRegisto'];

          if($data!=$oldData)
          {
               $oldData=$data;
               $datas[]=$oldData;
          }
          
     }    


     for($i=0;$i<sizeof($datas);$i++)
     { 
          $Recebidos=0;
          $A_Contatar=0;
          $N_Nao_Existe=0;
          $Sem_Interesse=0;
          $Venda_Leads=0;
          $Valor_Venda=0;
          $Contatadas=0;

          for($j=0;$j<sizeof($leads);$j++)
          {

              if($leads[$j]['DataHoraRegisto']==$datas[$i]) 
              {

                    $Recebidos++;

                    if($leads[$j]['Estado']=='Vou contatar' || $leads[$j]['Estado']=='Não atende') 
                    {
                          $A_Contatar++;
                    }
                    else if($leads[$j]['Estado']=='Número não existe') 
                    {
                          $N_Nao_Existe++;
                    }
                    else if(strpos($leads[$j]['Estado'],'Sem interesse:') !== false) 
                    {
                          $Sem_Interesse++;
                    }
                    else if(strpos($leads[$j]['Estado'],'Venda:') !== false) 
                    {
                          $Venda_Leads++;
                          $Valor_Venda += $leads[$j][ValorVenda];
                    }

                    if($leads[$j]['Estado']!='Vou contatar' && $leads[$j]['Estado']!='Recebido' && $leads[$j]['Estado']!='Número não existe')
                    {
                         $Contatadas++;
                    }

              }
          }

          $res[]=array('Date' => $datas[$i], 'Recebidos' => $Recebidos, 'A_Contatar' => $A_Contatar, 'Contatadas' => $Contatadas, 'N_Nao_Existe' => $N_Nao_Existe, 'Sem_Interesse' => $Sem_Interesse, 'Venda_Leads' => $Venda_Leads, 'Valor_Venda' => $Valor_Venda);

     }

     mysqli_close($con);

     return $res;
}
 

if($op=='getRDiario')
{
     echo json_encode(calculaRMesDia(-9));
}

if($op=='getRMes')
{
     echo json_encode(calculaRMesDia(-12));
}


if($op=='getRAno')
{
     //$con = mysqli_connect("localhost", "bluemark_OMHwp", "dtZtX8e9Xd1X", "bluemark_OMHwp")or die(json_encode("unconnected"));

     //coverte dados da tabela para utf8 devido aos acentos nos textos da tabela
     if (!mysqli_set_charset($con, "utf8")) 
     {
           json_encode("erro de caracter");
     } 

     $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History GROUP BY Lead ORDER BY DataHoraRegisto desc");

     while ($row = mysqli_fetch_assoc($result))// mysqli_fetch_array($result, MYSQL_ASSOC)) 
     {
          $leads[]=$row;
     }

     for($i=0;$i<sizeof($leads);$i++)
     {
          $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History where Lead='".$leads[$i]['Lead']."' order by DataHoraRegisto desc");

          $row = mysqli_fetch_assoc($result); //mysqli_fetch_array($result, MYSQL_ASSOC);

          $leads[$i]['Estado']=$row['Estado'];
          $leads[$i]['UserID']=$row['UserID'];
          $leads[$i]['ValorVenda']=$row['ValorVenda'];

          $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History where UserID='".$leads[$i]['UserID']."'");

          $row = mysqli_fetch_assoc($result); //mysqli_fetch_array($result, MYSQL_ASSOC);

          $leads[$i]['UserName']=$row['User'];

          $leads[$i]['DataHoraRegisto']=substr($leads[$i]['DataHoraRegisto'], 0, -12);

     }

     //datas 
     for($i=0;$i<sizeof($leads);$i++)
     {
          $data=$leads[$i]['DataHoraRegisto'];

          if($data!=$oldData)
          {
               $oldData=$data;
               $datas[]=$oldData;
          }
          
     }

     //get users names
     $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_Users");
     while ($row = mysqli_fetch_assoc($result))// mysqli_fetch_array($result, MYSQL_ASSOC)) 
     {
          $users[]=$row['User'];
     }

     for($i=0;$i<sizeof($datas);$i++)
     {
           for($j=0;$j<sizeof($users);$j++)
           {

                 $Contatadas=0;
                 $Venda=0;
                 $ValorVenda=0;

                 for($k=0;$k<sizeof($leads);$k++)
                 {
                       if($leads[$k]['DataHoraRegisto']==$datas[$i] && $leads[$k]['UserName']==$users[$j])
                       {
                             $leadsRes[] = array('Date' => $leads[$k]['DataHoraRegisto'], 'Estado' => $leads[$k]['Estado'], 'ValorVenda' => $leads[$k]['ValorVenda'], 'User' => $leads[$k]['UserName']);

                             if(strpos($leads[$k]['Estado'],'Venda:') !== false)
                             {
                                     $Venda++;
                                     $Contatadas++;
                                     $ValorVenda+=$leads[$k]['ValorVenda'];
                             }
                             else if($leads[$k]['Estado']!='Vou contatar' && $leads[$k]['Estado']!='Recebido' && $leads[$k]['Estado']!='Número não existe')
                             {
                                     $Contatadas++;
                             }
                       }
                 } 


                 if($Venda==0)
                 {
                       $VendaPer=0;
                 }
                 else
                 {
                       $VendaPer=$Venda/$Contatadas;
                 }

                 if($ValorVenda==0)
                 {
                       $VendasMedia=0;
                 }
                 else
                 {
                       $VendasMedia=$ValorVenda/$Venda;
                 }

                 $leadsRes2[] = array('Date' => $datas[$i], 'Operador' => $users[$j], 'Contatadas' => $Contatadas, 'Venda' => $Venda, 'ValorVenda' => $ValorVenda, 'VendaPer' => $VendaPer, 'VendasMedia' => $VendasMedia);
           }    
     }
     

     mysqli_close($con);

     echo json_encode($leadsRes2);

}


if($op=='getUserInfoVendas')
{
     //$con = mysqli_connect("localhost", "bluemark_OMHwp", "dtZtX8e9Xd1X", "bluemark_OMHwp")or die(json_encode("unconnected"));

     //coverte dados da tabela para utf8 devido aos acentos nos textos da tabela
     if (!mysqli_set_charset($con, "utf8")) 
     {
           json_encode("erro de caracter");
     } 

     $dataH=date('Y-m-d');
     $dataM=date('Y-m');
    
     if($nivelUser==1)
     {
           $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History where UserID=".$idUser." and (Estado!='Recebido' and Estado!='Vou contatar' and date(DataHoraRegisto)=date('".$dataH."')) group by Lead");
           $ContatadasH = mysqli_num_rows($result); 


           $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History where UserID=".$idUser." and (Estado!='Recebido' and Estado!='Vou contatar' and DataHoraRegisto like '%".$dataM."%') group by Lead");
           $ContatadasM=mysqli_num_rows($result);
     
           $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History where UserID=".$idUser." and Estado like '%Venda:%' and date(DataHoraRegisto)=date('".$dataH."') group by Lead");
           $VendasH=mysqli_num_rows($result);


           $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History where UserID=".$idUser." and Estado like '%Venda:%' and DataHoraRegisto like '%".$dataM."%' group by Lead");
           $VendasM=mysqli_num_rows($result);

           $result = mysqli_query($con,"SELECT SUM(ValorVenda) FROM LM_EspacoAbsoluto_History where UserID=".$idUser." and Estado like '%Venda:%' and date(DataHoraRegisto)=date('".$dataH."') group by UserID");

           $row = mysqli_fetch_assoc($result); //mysqli_fetch_array($result, MYSQL_ASSOC);

           $VVendasH=$row['SUM(ValorVenda)'];
           if($VVendasH === NULL)
           {
                $VVendasH=0;
           }
           else
           {
                $VVendas=intval($VVendasH);
           }

           $result = mysqli_query($con,"SELECT SUM(ValorVenda) FROM LM_EspacoAbsoluto_History where UserID=".$idUser." and Estado like '%Venda:%' and DataHoraRegisto like '%".$dataM."%' group by UserID");

           $row = mysqli_fetch_assoc($result); //mysqli_fetch_array($result, MYSQL_ASSOC);

           $VVendasM=$row['SUM(ValorVenda)'];

           if($VVendasM === NULL)
           {
                $VVendasM=0;
           }
           else
           {
                $VVendasM=intval($VVendasM);
           }
     }
     else
     {
           $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History where Estado!='Recebido' and Estado!='Vou contatar' and date(DataHoraRegisto)=date('".$dataH."') group by Lead");
           $ContatadasH = mysqli_num_rows($result); 


           $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History where Estado!='Recebido' and Estado!='Vou contatar' and DataHoraRegisto like '%".$dataM."%' group by Lead");
           $ContatadasM=mysqli_num_rows($result);
     
           $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History where Estado like '%Venda:%' and date(DataHoraRegisto)=date('".$dataH."') group by Lead");
           $VendasH=mysqli_num_rows($result);


           $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History where Estado like '%Venda:%' and DataHoraRegisto like '%".$dataM."%' group by Lead");
           $VendasM=mysqli_num_rows($result);

           $result = mysqli_query($con,"SELECT SUM(ValorVenda) FROM LM_EspacoAbsoluto_History where Estado like '%Venda:%' and date(DataHoraRegisto)=date('".$dataH."')");

           $row = mysqli_fetch_assoc($result); //mysqli_fetch_array($result, MYSQL_ASSOC);

           $VVendasH=$row['SUM(ValorVenda)'];
           if($VVendasH === NULL)
           {
                $VVendasH=0;
           }
           else
           {
                $VVendas=intval($VVendasH);
           }

           $result = mysqli_query($con,"SELECT SUM(ValorVenda) FROM LM_EspacoAbsoluto_History where Estado like '%Venda:%' and DataHoraRegisto like '%".$dataM."%'");

           $row = mysqli_fetch_assoc($result); //mysqli_fetch_array($result, MYSQL_ASSOC);

           $VVendasM=$row['SUM(ValorVenda)'];

           if($VVendasM === NULL)
           {
                $VVendasM=0;
           }
           else
           {
                $VVendasM=intval($VVendasM);
           }
     }

     $resultado= array('ContatadasH' => $ContatadasH, 'ContatadasM' => $ContatadasM, 'VendasH' => $VendasH, 'VendasM' => $VendasM, 'VVendasH' => $VVendasH, 'VVendasM' => $VVendasM);


     mysqli_close($con);

     echo json_encode($resultado);

}

if($op=='chec_lead_state')
{
     //$con = mysqli_connect("localhost", "bluemark_OMHwp", "dtZtX8e9Xd1X", "bluemark_OMHwp")or die(json_encode("unconnected"));

     //coverte dados da tabela para utf8 devido aos acentos nos textos da tabela
     if (!mysqli_set_charset($con, "utf8")) 
     {
           json_encode("erro de caracter");
     } 

     $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_History where Lead='".$infoAdicional['Email']."' ORDER BY DataHoraRegisto desc");

     $row = mysqli_fetch_assoc($result); //mysqli_fetch_array($result, MYSQL_ASSOC);

     mysqli_close($con);

     echo json_encode($row['Estado']);

}

if($op=='set_anotacao')
{
     //$con = mysqli_connect("localhost", "bluemark_OMHwp", "dtZtX8e9Xd1X", "bluemark_OMHwp")or die(json_encode("unconnected"));

     //coverte dados da tabela para utf8 devido aos acentos nos textos da tabela
     if (!mysqli_set_charset($con, "utf8")) 
     {
           json_encode("erro de caracter");
     } 


     $result = mysqli_query($con,"update LM_EspacoAbsoluto_History set Anotacoes='".$infoAdicional['Anotacao']."' where Lead ='".$infoAdicional['Email']."' and Estado='".$infoAdicional['Estado']."' order by DataHoraRegisto desc LIMIT 1");

     mysqli_close($con);

     echo json_encode($result);

}


if($op=='get_historico')
{
     //$con = mysqli_connect("localhost", "bluemark_OMHwp", "dtZtX8e9Xd1X", "bluemark_OMHwp")or die(json_encode("unconnected"));

     //coverte dados da tabela para utf8 devido aos acentos nos textos da tabela
     if (!mysqli_set_charset($con, "utf8")) 
     {
           json_encode("erro de caracter");
     } 


     $result = mysqli_query($con,"select * from LM_EspacoAbsoluto_History where Lead='".$infoAdicional['Email']."' order by DataHoraRegisto desc ");

     while ($row = mysqli_fetch_assoc($result))// mysqli_fetch_array($result, MYSQL_ASSOC)) 
     {
          if($row['UserID']!=0)
          {
                $result2 = mysqli_query($con,"select * from LM_EspacoAbsoluto_Users where UserID='".$row['UserID']."'");
                $row3 = mysqli_fetch_assoc($result2); //mysqli_fetch_array($result2, MYSQL_ASSOC);

                $row['UserName']=$row3['User'];
          }
          else
          {
                $row['UserName']='';
          }
                          
          $res[]=$row;
     }


     mysqli_close($con);
     echo json_encode($res);
}


if($op=='insert_historico')
{
     //$con = mysqli_connect("localhost", "bluemark_OMHwp", "dtZtX8e9Xd1X", "bluemark_OMHwp")or die(json_encode("unconnected"));

     //coverte dados da tabela para utf8 devido aos acentos nos textos da tabela
     if (!mysqli_set_charset($con, "utf8")) 
     {
           json_encode("erro de caracter");
     } 

     $dataHoraMudacao = date('Y-m-d H:i:s');

     $result = mysqli_query($con,"INSERT INTO LM_EspacoAbsoluto_History (Lead, UserID, DataHoraRegisto, Estado, ValorVenda) VALUES ('".$infoAdicional['Email']."', '".$idUser."', '".$dataHoraMudacao."', '".$infoAdicional['Estado']."', '".$infoAdicional['ValorVenda']."')");

     mysqli_close($con);
     echo json_encode($nameUser);
}

if($op=='getClients')
{
     //$con = mysqli_connect("localhost", "bluemark_OMHwp", "dtZtX8e9Xd1X", "bluemark_OMHwp")or die(json_encode("unconnected"));

     //coverte dados da tabela para utf8 devido aos acentos nos textos da tabela
     if (!mysqli_set_charset($con, "utf8")) 
     {
           json_encode("erro de caracter");
     } 

     $result = mysqli_query($con,"SELECT * FROM LM_EspacoAbsoluto_Users where UserID='".$idUser."'");
     // $utilizar = mysqli_fetch_array($result, MYSQL_ASSOC);
     $utilizar = mysqli_fetch_assoc($result);
     $nivelUser=$utilizar['Nivel'];

     //$result = mysqli_query($con,"SELECT * FROM LeadCampanha where Campanha='EspacoAbsoluto' and date(HorarioEnvio) >= date('2019-10-01')");
     //$result = mysqli_query($con,"SELECT * FROM LeadCampanha where Campanha='EspacoAbsoluto' and Resposta='Email Enviado' and date(HorarioEnvio) >= date('2015-01-01')");
     $result = mysqli_query($con,"SELECT * FROM LeadCampanha Where Campanha= 'LuciaPT' and date(DataHoraRegisto) >= date('2019-12-01') and Resposta= 'ok' group by lead");

     // while ($row = mysqli_fetch_array($result, MYSQL_ASSOC)) 
     while ($row = mysqli_fetch_assoc($result)) 
     {
          $leads[]=$row;
     }
     

     //$result = mysqli_query($con,"select * from OMH_registosLaura where TELEFONE!='' and Horario!='' group by EMAIL order by DataHoraRegisto desc LIMIT 1500");
     $result = mysqli_query($con,"select OMH_registosLaura.FNAME, OMH_registosLaura.LNAME, OMH_registosLaura.BDATE, OMH_registosLaura.GENDER, LeadCampanha.Lead, OMH_registosLaura.EMAIL, OMH_registosLaura.DESEJO, OMH_registosLaura.TELEFONE, OMH_registosLaura.SIGNO,  OMH_registosLaura.site from OMH_registosLaura right join LeadCampanha on OMH_registosLaura.EMAIL = LeadCampanha.Lead  where  LeadCampanha.Campanha = 'LuciaPT' and LeadCampanha.Resposta = 'ok' group by LeadCampanha.lead ORDER BY LeadCampanha.dataHoraRegisto DESC");

     // while ($row = mysqli_fetch_array($result, MYSQL_ASSOC)) 
     while ($row = mysqli_fetch_assoc($result)) 
     {
            for($i=0;$i<sizeof($leads);$i++)
            {
                  if($leads[$i]['Lead']==$row['EMAIL'])
                  {
                      $row['dataHoraRegisto']=$leads[$i]['DataHoraRegisto'];
                      $row['Horario']=$leads[$i]['HorarioEnvio'];
                      $res[]=$row;
                      continue;
                  }
            }
     }

     for($i=0;$i<sizeof($res);$i++)
     {

          $result = mysqli_query($con,"select * from LM_EspacoAbsoluto_History where Lead='".$res[$i]['EMAIL']."' order by DataHoraRegisto desc ");

          #$row = mysqli_fetch_array($result, MYSQL_ASSOC);
          $row = mysqli_fetch_assoc($result);
          $res[$i]['Estado']=$row['Estado'];
          $res[$i]['Anotacoes']=$row['Anotacoes'];
          $res[$i]['ValorVenda']=$row['ValorVenda'];
        
          $res[$i]['FNAME']=$res[$i]['FNAME'].' '.$res[$i]['LNAME'];
          
          if($row['UserID']==0)
          {
                //$res[$i]['Operador']='NA';
                $res[$i]['Operador']='';

          }
          else
          {
                $result = mysqli_query($con,"select * from LM_EspacoAbsoluto_Users where UserID='".$row['UserID']."'");
               //  $row2 = mysqli_fetch_array($result, MYSQL_ASSOC);
                $row = mysqli_fetch_assoc($result);
                $res[$i]['Operador']=$row2['User'];
          }
 
          $horasLead = explode(" ", $res[$i]['Horario']);

          $horaAtual = date('H:i');
          
          if($res[$i]['Horario']=='o mais depressa possível' && $res[$i]['Estado']=='Recebido')
          {
               $res[$i]['Contatar']='Sim';
          }
          else if($res[$i]['Horario']=='antes das 13:00' && $horasLead[2]>$horaAtual && $res[$i]['Estado']=='Recebido')
          {
               $res[$i]['Contatar']='Sim';
          }
          else if($res[$i]['Horario']=='depois das 18:00' && $horasLead[2]<$horaAtual && $res[$i]['Estado']=='Recebido')
          {
               $res[$i]['Contatar']='Sim';
          }
          else if($horasLead[2]<=$horaAtual && $horaAtual<=$horasLead[5] && $res[$i]['Estado']=='Recebido')
          {
               $res[$i]['Contatar']='Sim';
          }
          else if($res[$i]!='')
          {
               $res[$i]['Contatar']='Nao';
          }
     }


     //remove os que estão a mais
     for($i=0;$i<sizeof($res);$i++)
     {
          if($nivelUser==2)
          {
               $resfinal[]=$res[$i];
          }
          else if($nivelUser==1 && ($res[$i]['Operador']==$nameUser || $res[$i]['Operador']=='NA'))
          {
               $resfinal[]=$res[$i];
          }
     }

     mysqli_close($con);

     echo json_encode($resfinal);

}


?>